'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _gatsbyHelpers = require('./gatsby-helpers');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stats = void 0;
try {
  stats = require('public/stats.json');
} catch (e) {
  // ignore
}

var HTMLScripts = function HTMLScripts(_ref) {
  var scripts = _ref.scripts;

  var scriptComponents = void 0;
  if (process.env.NODE_ENV === 'production') {
    scriptComponents = scripts.map(function (script) {
      var fetchKey = 'assetsByChunkName[' + script + '][0]';
      return _react2.default.createElement('script', { key: script, src: (0, _gatsbyHelpers.prefixLink)('/' + (0, _get2.default)(stats, fetchKey, '')) });
    });
  } else {
    scriptComponents = _react2.default.createElement('script', { src: (0, _gatsbyHelpers.prefixLink)('/' + scripts[0] + '.js') });
  }

  return _react2.default.createElement(
    'div',
    null,
    scriptComponents
  );
};

HTMLScripts.propTypes = {
  scripts: _react2.default.PropTypes.array.isRequired
};

module.exports = HTMLScripts;