'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _graphql = require('graphql');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inferGraphQLType = function inferGraphQLType(key, value) {
  if (Array.isArray(value)) {
    var headType = inferGraphQLType('', value[0]);
    return new _graphql.GraphQLList(headType);
  }

  if (value === null) {
    return null;
  }

  // Check if date object.
  if (typeof value.getMonth === 'function') {
    return 'DATE';
  }

  switch (typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) {
    case 'boolean':
      return _graphql.GraphQLBoolean;
    case 'string':
      return _graphql.GraphQLString;
    case 'object':
      return _graphql.GraphQLObjectType;
    case 'number':
      return value % 1 === 0 ? _graphql.GraphQLInt : _graphql.GraphQLFloat;
    default:
      return null;
  }
};

module.exports = inferGraphQLType;