'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpack3 = require('./webpack.config');

var _webpack4 = _interopRequireDefault(_webpack3);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _globals = require('./globals');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*  weak */
require('node-cjsx').transform();

var debug = require('debug')('gatsby:html');


module.exports = function (program, callback) {
  var directory = program.directory;


  debug('generating static HTML');
  // Reduce pages objects to an array of paths.
  var pages = [].concat((0, _toConsumableArray3.default)((0, _globals.pagesDB)().values())).map(function (page) {
    return page.path;
  });

  // Static site generation.
  var compilerConfig = (0, _webpack4.default)(program, directory, 'build-html', null, pages);

  (0, _webpack2.default)(compilerConfig.resolve()).run(function (e, stats) {
    if (e) {
      return callback(e, stats);
    }
    if (stats.hasErrors()) {
      return callback('Error: ' + stats.toJson().errors, stats);
    }

    // Remove the temp JS bundle file built for the static-site-generator-plugin
    _fs2.default.unlinkSync(directory + '/public/render-page.js');

    return callback(null, stats);
  });
};