'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _toml = require('toml');

var _toml2 = _interopRequireDefault(_toml);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _buildCss = require('./build-css');

var _buildCss2 = _interopRequireDefault(_buildCss);

var _buildHtml = require('./build-html');

var _buildHtml2 = _interopRequireDefault(_buildHtml);

var _buildJavascript = require('./build-javascript');

var _buildJavascript2 = _interopRequireDefault(_buildJavascript);

var _postBuild = require('./post-build');

var _postBuild2 = _interopRequireDefault(_postBuild);

var _bootstrap = require('../bootstrap');

var _bootstrap2 = _interopRequireDefault(_bootstrap);

var _globals = require('./globals');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function customPost(program, callback) {
  var directory = program.directory;
  var customPostBuild = void 0;
  //try {
  //// $FlowIssue - https://github.com/facebook/flow/issues/1975
  //const gatsbyNodeConfig = require(`${directory}/gatsby-node`)
  //customPostBuild = gatsbyNodeConfig.postBuild
  //} catch (e) {
  //if (e.code !== `MODULE_NOT_FOUND` && !_.includes(e.Error, `gatsby-node`)) {
  //console.log(`Failed to load gatsby-node.js, skipping custom post build script`, e)
  //}
  //}

  if (customPostBuild) {
    console.log('Performing custom post-build steps');

    customPostBuild((0, _globals.pagesDB)(), function (error) {
      if (error) {
        console.log('customPostBuild function failed');
        callback(error);
      }
      return callback();
    });
  }

  return callback();
} /*  weak */


function post(program, callback) {
  console.log('Copying assets');

  //postBuild(program, (error) => {
  //if (error) {
  //console.log(`failed to copy assets`)
  //return callback(error)
  //}

  return customPost(program, callback);
  //})
}

function bundle(program, callback) {
  console.log('Compiling production bundle.js');

  (0, _buildJavascript2.default)(program, function (error, stats) {
    // Write out stats.json file for easy analysis of module & chunk structure
    // in http://webpack.github.io/analyse/ and
    // https://alexkuz.github.io/stellar-webpack/
    //console.log(`${os.tmpdir()}/gatsby-build-${new Date().toJSON()}---stats.json`)
    //fs.writeFileSync(
    //`${os.tmpdir()}/gatsby-build-${new Date().toJSON()}---stats.json`,
    //JSON.stringify(stats.toJson())
    //)
    if (error) {
      console.log('failed to compile bundle.js');
      return callback(error);
    }
    return callback();
  });
}

function html(program, callback) {
  var directory = program.directory;

  return (0, _bootstrap2.default)(program, function (err) {
    console.log('Generating CSS');
    (0, _buildCss2.default)(program, function (cssError) {
      if (cssError) {
        console.log('Failed at generating styles.css');
        return callback(cssError);
      }

      return bundle(program, function (javascriptError) {
        if (javascriptError) {
          console.log('Failed at building Javascript bundles');
          return callback(javascriptError);
        }
        console.log('Generating Static HTML');
        // Write out pages data to file so it's available to the static-entry.js
        // file.
        _fs2.default.writeFileSync(program.directory + '/public/tmp-pages.json', (0, _stringify2.default)([].concat((0, _toConsumableArray3.default)((0, _globals.pagesDB)().values()))));
        return (0, _buildHtml2.default)(program, function (htmlError) {
          if (htmlError) {
            console.log('Failed at generating HTML');
            return callback(htmlError);
          }
          return post(program, callback);
        });
      });
    });
  });
}

module.exports = html;