'use strict';

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var path = require('path');

var pathChunkName = function pathChunkName(path) {
  var name = path === '/' ? 'index' : (0, _kebabCase3.default)(path);
  return 'path---' + name;
};

var layoutComponentChunkName = function layoutComponentChunkName(directory, componentPath) {
  var name = path.relative(directory, componentPath);
  return 'page-component---' + (0, _kebabCase3.default)(name);
};

exports.pathChunkName = pathChunkName;
exports.layoutComponentChunkName = layoutComponentChunkName;