'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _reactRouter = require('react-router');

var _html = require('html');

var _html2 = _interopRequireDefault(_html);

var _gatsbyHelpers = require('../isomorphic/gatsby-helpers');

var _childRoutes = require('.intermediate-representation/child-routes.js');

var _childRoutes2 = _interopRequireDefault(_childRoutes);

var _tmpPages = require('public/tmp-pages.json');

var _tmpPages2 = _interopRequireDefault(_tmpPages);

var _jsChunkNames = require('./js-chunk-names');

var _apiRunnerSsr = require('../utils/api-runner-ssr');

var _apiRunnerSsr2 = _interopRequireDefault(_apiRunnerSsr);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (locals, callback) {
  (0, _reactRouter.match)({ routes: _childRoutes2.default, location: locals.path }, function (error, redirectLocation, renderProps) {
    if (error) {
      console.log('error when building page ' + locals.path, error);
      callback(error);
    } else if (renderProps) {
      var component = _react2.default.createElement(_reactRouter.RouterContext, renderProps);

      // Let the site or plugin render the page component.
      var results = (0, _apiRunnerSsr2.default)('replaceServerBodyRender', { component: component, headComponents: [] }, {});
      var body = results.body,
          headComponents = results.headComponents,
          bodyRenderProps = (0, _objectWithoutProperties3.default)(results, ['body', 'headComponents']);

      // If no one stepped up, we'll handle it.

      if (!body) {
        body = (0, _server.renderToString)(component);
        bodyRenderProps = {};
      }

      if (!headComponents) {
        headComponents = [];
      }

      // Add the chunk-manifest as a head component.
      var chunkManifest = require('!raw!public/chunk-manifest.json');

      headComponents.push(_react2.default.createElement('script', {
        id: 'webpack-manifest',
        dangerouslySetInnerHTML: { __html: '\n          //<![CDATA[\n          window.webpackManifest = ' + chunkManifest + '\n          //]]>\n          ' }
      }));

      var scripts = ['commons', 'app'];
      // Path chunk.
      scripts.push((0, _jsChunkNames.pathChunkName)(locals.path));
      // layout component chunk
      scripts.push(_tmpPages2.default.find(function (page) {
        return page.path === locals.path;
      }).componentChunkName);

      var html = '<!DOCTYPE html>\n ' + (0, _server.renderToStaticMarkup)(_react2.default.createElement(_html2.default, (0, _extends3.default)({}, bodyRenderProps, {
        body: body,
        headComponents: headComponents
      }, renderProps, {
        scripts: scripts
      })));
      callback(null, html);
    } else {
      console.log('Couldn\'t match ' + locals.path + ' against your routes. This\n      should NEVER happen.');
      callback(null, 'FAIL ALERT');
    }
  });
};